#include <iostream>
#include <stdlib.h>
#include <string.h>
#include <time.h>

using namespace std;

const int N = 1000000;
unsigned long x[N]; // Assuming sizeof(unsigned long) == 8, or 64 bits.
int counts[64] = {0};

void count_simple(void) {
    for(int i = 0; i < N; i++) {
        int j = 0;
        while(x[i] != 0) {
            counts[j] += x[i] & 1;
            x[i] >>= 1;
            ++j;
        }
    }
}

void count_3bit(void) {
    for(int i = 0; i < N;) {
        int n = 0;
        unsigned long b1 = 0, b2 = 0, b3 = 0;
        unsigned long t1, t2, t3, c;

        if(i + n >= N) goto end;
        b1 = x[i + n];
        n = 1;

        if(i + n >= N) goto end;
        t1 = b1 ^ x[i + n];
        c = b1 & x[i + n];
        t2 = c;
        b1 = t1;
        b2 = t2;
        n = 2;

        if(i + n >= N) goto end;
        t1 = b1 ^ x[i + n];
        c = b1 & x[i + n];
        t2 = b2 | c;
        b1 = t1;
        b2 = t2;
        n = 3;

        if(i + n >= N) goto end;
        t1 = b1 ^ x[i + n];
        c = b1 & x[i + n];
        t2 = b2 ^ c;
        c = b2 & c;
        t3 = b3 | c;
        b1 = t1;
        b2 = t2;
        b3 = t3;
        n = 4;

        if(i + n >= N) goto end;
        t1 = b1 ^ x[i + n];
        c = b1 & x[i + n];
        t2 = b2 ^ c;
        c = b2 & c;
        t3 = b3 | c;
        b1 = t1;
        b2 = t2;
        b3 = t3;
        n = 5;

        if(i + n >= N) goto end;
        t1 = b1 ^ x[i + n];
        c = b1 & x[i + n];
        t2 = b2 ^ c;
        c = b2 & c;
        t3 = b3 | c;
        b1 = t1;
        b2 = t2;
        b3 = t3;
        n = 6;

        if(i + n >= N) goto end;
        t1 = b1 ^ x[i + n];
        c = b1 & x[i + n];
        t2 = b2 ^ c;
        c = b2 & c;
        t3 = b3 | c;
        b1 = t1;
        b2 = t2;
        b3 = t3;
        n = 7;

    end:
        for(int j = 0; j < 64; j++) {
            counts[j] += 4 * (b3 & 1) + 2 * (b2 & 1) + 1 * (b1 & 1);
            b1 >>= 1;
            b2 >>= 1;
            b3 >>= 1;
        }
        i += n;
    }
}

int main(int argc, char *argv[]) {

    void (*count)(void);

    if     (argc == 2 && strcmp(argv[1], "simple") == 0) count = count_simple;
    else if(argc == 2 && strcmp(argv[1], "3bit")   == 0) count = count_3bit;
    else {
        cerr << argv[0] << " simple|3bit" << endl;
        return -1;
    }

    for(int i = 0; i < N; i++) {
        x[i] = ((unsigned long)rand() << 32) | rand();
    }

    clock_t start = clock();
    count();
    clock_t end = clock();

    for(int j = 0; j < 64; j++) {
        cout << j << ": " << counts[j] << endl;
    }

    cout << "Time: " << ((end - start + 0.0) / CLOCKS_PER_SEC) << endl;

    return 0;
}
