#!/usr/bin/env python

import random
import sys
import time

N = 10000
x = [0] * N
counts = [0] * N

def count_simple():
    for i in range(N):
        j = 0
        while x[i] != 0:
            counts[j] += x[i] & 1
            x[i] >>= 1
            j += 1

def count_3bit():
    i = 0
    while i < N:
        try:
            n = 0
            b1 = 0
            b2 = 0
            b3 = 0

            if i + n >= N: raise Exception()
            b1 = x[i + n]
            n = 1

            if i + n >= N: raise Exception()
            t1 = b1 ^ x[i + n]
            c = b1 & x[i + n]
            t2 = c
            b1 = t1
            b2 = t2
            n = 2

            if i + n >= N: raise Exception()
            t1 = b1 ^ x[i + n]
            c = b1 & x[i + n]
            t2 = b2 | c
            b1 = t1
            b2 = t2
            n = 3

            if i + n >= N: raise Exception()
            t1 = b1 ^ x[i + n]
            c = b1 & x[i + n]
            t2 = b2 ^ c
            c = b2 & c
            t3 = b3 | c
            b1 = t1
            b2 = t2
            b3 = t3
            n = 4

            if i + n >= N: raise Exception()
            t1 = b1 ^ x[i + n]
            c = b1 & x[i + n]
            t2 = b2 ^ c
            c = b2 & c
            t3 = b3 | c
            b1 = t1
            b2 = t2
            b3 = t3
            n = 5

            if i + n >= N: raise Exception()
            t1 = b1 ^ x[i + n]
            c = b1 & x[i + n]
            t2 = b2 ^ c
            c = b2 & c
            t3 = b3 | c
            b1 = t1
            b2 = t2
            b3 = t3
            n = 6

            if i + n >= N: raise Exception()
            t1 = b1 ^ x[i + n]
            c = b1 & x[i + n]
            t2 = b2 ^ c
            c = b2 & c
            t3 = b3 | c
            b1 = t1
            b2 = t2
            b3 = t3
            n = 7
        except Exception:
            pass

        for j in range(64):
            counts[j] += 4 * (b3 & 1) + 2 * (b2 & 1) + 1 * (b1 & 1)
            b1 >>= 1
            b2 >>= 1
            b3 >>= 1
        i += n

def main():
    if   len(sys.argv) == 2 and sys.argv[1] == "simple": count = count_simple
    elif len(sys.argv) == 2 and sys.argv[1] == "3bit":   count = count_3bit
    else:
        print(sys.argv[0] + " simple|3bit")
        return

    for i in range(N):
        x[i] = (random.randint(0, 2**31 - 1) << 32) | random.randint(0, 2**31 - 1)

    start = time.time()
    count()
    end = time.time()

    for j in range(64):
        print("%d: %d" % (j, counts[j]))

    print("Time: %f" % (end - start))

main()
